<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/utils.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('utils_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">utils.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="utils_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;SDL2/SDL.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_ray_tracer_8hpp.html">RayTracer.hpp</a>&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_scene_8hpp.html">Scene.hpp</a>&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vec_8hpp.html">Vec.hpp</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_transform_8hpp.html">Transform.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_ray_tracer_8hpp.html">RayTracer.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keywordtype">void</span> <a class="code" href="utils_8hpp.html#adbd1409868b52e433ed84baf91620dff">main_loop</a>(<a class="code" href="class_ray_tracer.html">RayTracer</a> &amp;renderer, <span class="keywordtype">void</span>(*callback)(<a class="code" href="class_ray_tracer.html">RayTracer</a>*, SDL_Event&amp;), <span class="keywordtype">bool</span> view_look_at_sphere, <span class="keywordtype">bool</span> refresh_bvh, <span class="keywordtype">bool</span> default_events);</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keywordtype">void</span> <a class="code" href="utils_8hpp.html#a37bdfd1760746e99eb5ca412b996b518">LightBulb</a>(<a class="code" href="class_scene.html">Scene</a>* scene, <span class="keyword">const</span> <a class="code" href="class_vec.html">Vec</a> &amp;pos, <span class="keyword">const</span> <a class="code" href="class_vec.html">Vec</a> &amp;cl, <span class="keywordtype">double</span> decay, <a class="code" href="class_transform.html">Transform</a> *tf);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keywordtype">int</span> <a class="code" href="utils_8hpp.html#affc96c8859e998422a378d17baf5cb15">CornellBox</a>(<a class="code" href="class_scene.html">Scene</a>* scene, <a class="code" href="class_transform.html">Transform</a> *tf);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keywordtype">int</span> <a class="code" href="utils_8hpp.html#a8bb50e55e89fa38966a77ec9f4b96c6d">CornellBoxTextured</a>(<a class="code" href="class_scene.html">Scene</a>* scene, <a class="code" href="class_transform.html">Transform</a> *tf);</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keywordtype">void</span> <a class="code" href="utils_8hpp.html#aa94606ba1e128dfa257cc54b1123a4e0">print_matrix</a>(std::vector&lt;int&gt; level_matrix);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keywordtype">void</span> <a class="code" href="utils_8hpp.html#abb666dff602c2d32f3a90c1a1aa11736">drawBox</a>(<a class="code" href="class_scene.html">Scene</a>* scene, <a class="code" href="class_material.html">Material</a> *m, <a class="code" href="class_box.html">Box</a> box);</div><div class="ttc" id="utils_8hpp_html_a8bb50e55e89fa38966a77ec9f4b96c6d"><div class="ttname"><a href="utils_8hpp.html#a8bb50e55e89fa38966a77ec9f4b96c6d">CornellBoxTextured</a></div><div class="ttdeci">int CornellBoxTextured(Scene *scene, Transform *tf)</div><div class="ttdoc">Creates a textured Cornell Box. </div><div class="ttdef"><b>Definition:</b> utils.cpp:244</div></div>
<div class="ttc" id="utils_8hpp_html_abb666dff602c2d32f3a90c1a1aa11736"><div class="ttname"><a href="utils_8hpp.html#abb666dff602c2d32f3a90c1a1aa11736">drawBox</a></div><div class="ttdeci">void drawBox(Scene *scene, Material *m, Box box)</div><div class="ttdoc">Draws a given bounding box of type Box. </div><div class="ttdef"><b>Definition:</b> utils.cpp:330</div></div>
<div class="ttc" id="utils_8hpp_html_aa94606ba1e128dfa257cc54b1123a4e0"><div class="ttname"><a href="utils_8hpp.html#aa94606ba1e128dfa257cc54b1123a4e0">print_matrix</a></div><div class="ttdeci">void print_matrix(std::vector&lt; int &gt; level_matrix)</div><div class="ttdef"><b>Definition:</b> utils.cpp:279</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="utils_8hpp_html_a37bdfd1760746e99eb5ca412b996b518"><div class="ttname"><a href="utils_8hpp.html#a37bdfd1760746e99eb5ca412b996b518">LightBulb</a></div><div class="ttdeci">void LightBulb(Scene *scene, const Vec &amp;pos, const Vec &amp;cl, double decay, Transform *tf)</div><div class="ttdoc">Associates a Light object with a Sphere to create a light bulb. </div><div class="ttdef"><b>Definition:</b> utils.cpp:191</div></div>
<div class="ttc" id="utils_8hpp_html_adbd1409868b52e433ed84baf91620dff"><div class="ttname"><a href="utils_8hpp.html#adbd1409868b52e433ed84baf91620dff">main_loop</a></div><div class="ttdeci">void main_loop(RayTracer &amp;renderer, void(*callback)(RayTracer *, SDL_Event &amp;), bool view_look_at_sphere, bool refresh_bvh, bool default_events)</div><div class="ttdef"><b>Definition:</b> utils.cpp:13</div></div>
<div class="ttc" id="class_material_html"><div class="ttname"><a href="class_material.html">Material</a></div><div class="ttdoc">A class to create and manipulate surface materials. </div><div class="ttdef"><b>Definition:</b> Material.hpp:19</div></div>
<div class="ttc" id="class_scene_html"><div class="ttname"><a href="class_scene.html">Scene</a></div><div class="ttdoc">A class to create and control scenes from Surface and Light objects. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:23</div></div>
<div class="ttc" id="class_ray_tracer_html"><div class="ttname"><a href="class_ray_tracer.html">RayTracer</a></div><div class="ttdoc">A class to create and manipulate surface materials. </div><div class="ttdef"><b>Definition:</b> RayTracer.hpp:20</div></div>
<div class="ttc" id="_transform_8hpp_html"><div class="ttname"><a href="_transform_8hpp.html">Transform.hpp</a></div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="_vec_8hpp_html"><div class="ttname"><a href="_vec_8hpp.html">Vec.hpp</a></div></div>
<div class="ttc" id="utils_8hpp_html_affc96c8859e998422a378d17baf5cb15"><div class="ttname"><a href="utils_8hpp.html#affc96c8859e998422a378d17baf5cb15">CornellBox</a></div><div class="ttdeci">int CornellBox(Scene *scene, Transform *tf)</div><div class="ttdoc">Creates a simple Cornell Box. </div><div class="ttdef"><b>Definition:</b> utils.cpp:211</div></div>
<div class="ttc" id="class_box_html"><div class="ttname"><a href="class_box.html">Box</a></div><div class="ttdef"><b>Definition:</b> Box.hpp:12</div></div>
<div class="ttc" id="_scene_8hpp_html"><div class="ttname"><a href="_scene_8hpp.html">Scene.hpp</a></div></div>
<div class="ttc" id="_ray_tracer_8hpp_html"><div class="ttname"><a href="_ray_tracer_8hpp.html">RayTracer.hpp</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="utils_8hpp.html">utils.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
